Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deTBST< T, N > Class Template Reference

templated binary tree storage class More...

`#include <deBST.hpp>`

Inheritance diagram for deTBST< T, N >:

[legend]
Collaboration diagram for deTBST< T, N >:

[legend]
List of all members.

## Public Member Functions
| deTBST ()
| deTBST (const deTBST< T, N > &ref)
const deTBST< T, N > & | operator= (const deTBST< T, N > &ref)
| ~deTBST ()
void | EmptyBST ()
void * | GetRoot (T *&obj, DWORD value[N]) const
void * | FindValue (const DWORD Val[N], T *&obj) const
void * | FindValue (const DWORD Val[N], T &obj) const
void * | GetLeftMost (T *&obj, DWORD value[N])
void * | GetLeftMostLeaf (T *&obj, DWORD value[N])
void * | GetLeftMost (T &obj, DWORD value[N])
void * | GetNextRight (void *current, T *&obj, DWORD value[N])
void * | GetNextRight (void *current, T &obj, DWORD value[N])
void * | GetNextChain (void *current, T *&obj) const
void * | GetNextChain (void *current, T &obj) const
void * | AddElement (const T &data, const DWORD Val[N])
deBoolean | RemoveElement (void *ptr)
T * | GetData (void *ptr)
void | GetDataPList (deTList< T * > &list)
void | GetValueList (deTList< DWORD > &list)
long | Length () const
long | size () const
iterator | begin ()
iterator | end ()
iterator | insert (const T &data, const DWORD Val[N])
iterator | erase (iterator &it)
## Static Public Member Functions
void | StaticRemoveElement (void *ptr)
## Private Attributes
TBSTNode * | m_Root
long | m_Length

## Detailed Description

### template<class T, long N>
class deTBST< T, N >

templated binary tree storage class

## Constructor & Destructor Documentation

template<class T, long N>
deTBST< T, N >::deTBST | ( |  | ) | `[inline]`

template<class T, long N>
deTBST< T, N >::deTBST | ( | const deTBST< T, N > & | ref | ) | `[inline]`

template<class T, long N>
deTBST< T, N >::~deTBST | ( |  | ) | `[inline]`

## Member Function Documentation

template<class T, long N>
void* deTBST< T, N >::AddElement | ( | const T & | data,
|  | const DWORD | Val[N]
| ) | `[inline]`

template<class T, long N>
iterator deTBST< T, N >::begin | ( |  | ) | `[inline]`

template<class T, long N>
void deTBST< T, N >::EmptyBST | ( |  | ) | `[inline]`

template<class T, long N>
iterator deTBST< T, N >::end | ( |  | ) | `[inline]`

template<class T, long N>
iterator deTBST< T, N >::erase | ( | iterator & | it | ) | `[inline]`

template<class T, long N>
void* deTBST< T, N >::FindValue | ( | const DWORD | Val[N],
|  | T & | obj
| ) | const`[inline]`

template<class T, long N>
void* deTBST< T, N >::FindValue | ( | const DWORD | Val[N],
|  | T *& | obj
| ) | const`[inline]`

template<class T, long N>
T* deTBST< T, N >::GetData | ( | void * | ptr | ) | `[inline]`

template<class T, long N>
void deTBST< T, N >::GetDataPList | ( | deTList< T * > & | list | ) | `[inline]`

template<class T, long N>
void* deTBST< T, N >::GetLeftMost | ( | T & | obj,
|  | DWORD | value[N]
| ) | `[inline]`

template<class T, long N>
void* deTBST< T, N >::GetLeftMost | ( | T *& | obj,
|  | DWORD | value[N]
| ) | `[inline]`

template<class T, long N>
void* deTBST< T, N >::GetLeftMostLeaf | ( | T *& | obj,
|  | DWORD | value[N]
| ) | `[inline]`

template<class T, long N>
void* deTBST< T, N >::GetNextChain | ( | void * | current,
|  | T & | obj
| ) | const`[inline]`

template<class T, long N>
void* deTBST< T, N >::GetNextChain | ( | void * | current,
|  | T *& | obj
| ) | const`[inline]`

template<class T, long N>
void* deTBST< T, N >::GetNextRight | ( | void * | current,
|  | T & | obj,
|  | DWORD | value[N]
| ) | `[inline]`

template<class T, long N>
void* deTBST< T, N >::GetNextRight | ( | void * | current,
|  | T *& | obj,
|  | DWORD | value[N]
| ) | `[inline]`

template<class T, long N>
void* deTBST< T, N >::GetRoot | ( | T *& | obj,
|  | DWORD | value[N]
| ) | const`[inline]`

template<class T, long N>
void deTBST< T, N >::GetValueList | ( | deTList< DWORD > & | list | ) | `[inline]`

template<class T, long N>
iterator deTBST< T, N >::insert | ( | const T & | data,
|  | const DWORD | Val[N]
| ) | `[inline]`

template<class T, long N>
long deTBST< T, N >::Length | ( |  | ) | const`[inline]`

template<class T, long N>
const deTBST<T, N>& deTBST< T, N >::operator= | ( | const deTBST< T, N > & | ref | ) | `[inline]`

template<class T, long N>
deBoolean deTBST< T, N >::RemoveElement | ( | void * | ptr | ) | `[inline]`

template<class T, long N>
long deTBST< T, N >::size | ( |  | ) | const`[inline]`

template<class T, long N>
void deTBST< T, N >::StaticRemoveElement | ( | void * | ptr | ) | `[inline, static]`

## Member Data Documentation

template<class T, long N>
long deTBST< T, N >::m_Length`[private]`

template<class T, long N>
TBSTNode* deTBST< T, N >::m_Root`[private]`

The documentation for this class was generated from the following file:

- deBST.hpp